<div class="modal whmcs-modal fade in" id="clientPasswordModal" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog modal-lg">
        <div class="modal-content panel panel-primary">
            <div class="modal-header panel-heading" id="clientPasswordModalHeader">
                <button id="clientPasswordModalCloseSmall" type="button" class="close" data-dismiss="modal">
                    <span aria-hidden="true">&times;</span>
                    <span class="sr-only">Close</span>
                </button>
                <h4 class="model-title" id="clientPasswordModalTitle">Changing password for: <span id="clientName">N/A</span> (<span id="clientEmail">(N/A)</span>)</h4>
            </div>
            <div class="modal-body panel-body" id="clientPasswordModalBody">
                <div class="alert alert-danger admin-modal-error clientPasswordModalAlert" style="display: none;"></div>
                <div class="admin-tabs-v2">
                    <div class="tab-content">
                        <div class="tab-pane active">
                            <div class="form-group">
                                <label for="newPasswordInput" class="col-md-2 col-sm-4 control-label">New Password</label>
                                <div class="col-md-10 col-sm-8">
                                    <div class="input-group">
                                        <input type="text" id="newPasswordInput" class="form-control" />
                                        <span class="input-group-addon">
                                            <a href="#" id="generatePassword"><i class="glyphicon glyphicon-repeat"></i></a>
                                        </span>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <input type="hidden" id="userId" value="">
            </div>
            <div class="modal-footer panel-footer" id="clientPasswordModalFooter">
                <div id="modalFooterLeft"></div>
                <div class="pull-left loader" id="clientPasswordModalLoader" style="display: none;">
                    <i class="fas fa-circle-notch fa-spin"></i>
                    Loading...
                </div>
                <button id="clientPasswordModalClose" type="button" class="btn btn-default" data-dismiss="modal">
                    Close
                </button>
                <button type="button" class="btn btn-primary modal-submit" id="btnSave">Change</button>
            </div>
        </div>
    </div>
</div>

<script>
    $(document).ready(function () {
        $('.btn-permissions').each(function (i, obj) {
            $(this).after('<a href="#" data-user-id="' + $(this).attr('data-user-id') + '" class="btn btn-default changePasswordBtn">Change Password</a>');
        });

        $('.open-modal.manage-user').each(function (i, obj) {
            let id = $(this).attr('href').replace( /^\D+/g, '');
            $(this).after('<a href="#" data-user-id="' + id + '" class="btn btn-default btn-sm changePasswordBtn">Change Pass</a>');
        });


        $('.changePasswordBtn').on('click', function (e) {
            e.preventDefault();
            let userID = $(this).attr('data-user-id');
            $.ajax({
                type: 'POST',
                url: '{$moduleLink}&action=data',
                data: 'user=' + userID + '&csrfToken={$csrfToken}',
                beforeSend: function () {
                    $('#modalChangePwLoader').fadeIn();
                    $('.modalChangePwAlert').removeClass('alert-success').addClass('alert-danger').html('').hide();
                    $('#newPasswordInput').val('');
                },
                success: function (res) {
                    $('#userId').val(userID);
                    $('#clientName').html(res.data.fullName);
                    $('#clientEmail').html(res.data.email);
                },
                complete: function () {
                    $('#clientPasswordModalLoader').fadeOut();
                    $('#clientPasswordModal').modal('show');
                }
            });
        });

        $('#btnSave').on('click', function (e) {
            e.preventDefault();
            let userID = $('#userId').val();
            let password = encodeURIComponent($('#newPasswordInput').val());
            $.ajax({
                type: 'POST',
                url: '{$moduleLink}&action=change',
                data: 'user=' + userID + '&password=' + password + '&csrfToken={$csrfToken}',
                success: function (res) {
                    if (res.status === 'success') {
                        $('.clientPasswordModalAlert').removeClass('alert-danger').addClass('alert-success');
                        $('#newPasswordInput').val('');
                    } else {
                        $('.clientPasswordModalAlert').removeClass('alert-success').addClass('alert-danger');
                    }
                    $('.clientPasswordModalAlert').html(res.description).fadeIn();
                }
            });
        });

        $('#generatePassword').on('click', function (e) {
            e.preventDefault();
            const length = '{$passwordLength}';
            let charset = "abcdefghijklmnopqrstuvwxyz", retVal  = "";

            {if $useCapitalLetters}charset += 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';{/if}
            {if $useNumbers}charset += '0123456789';{/if}
            {if $useSpecialCharacters}charset += '+-*/$£%!&';{/if}

            for (let i = 0, n = charset.length; i < length; ++i) {
                retVal += charset.charAt(Math.floor(Math.random() * n));
            }

            $('#newPasswordInput').val(retVal);
        });

        $('#newPasswordInput').keyup(function (e) {
            if (e.which === 13) {
                $('#btnSave').click();
            }
        });
    });
</script>